xonotic/all

461 lines
9.7 KiB
Plaintext
Raw Normal View History

2010-03-18 15:46:07 +00:00
#!/bin/sh
# vim: filetype=zsh
2010-03-18 15:46:07 +00:00
set -e
d00=`pwd`
while ! [ -f ./all ]; do
if [ x"`pwd`" = x"/" ]; then
echo "Cannot find myself."
echo "Please run this script with the working directory inside a Xonotic checkout."
exit 1
fi
cd ..
done
d0=`pwd`
SELF="$d0/all"
# If we are on WINDOWS:
case "$0" in
all|*/all)
case "`uname`" in
MINGW*|Win*)
# Windows hates users. So this script has to copy itself elsewhere first...
tname=
2010-04-02 18:35:19 +00:00
cp "$SELF" ../all.xonotic.sh
exec ../all.xonotic.sh "$@"
;;
esac
;;
esac
2010-03-29 13:21:24 +00:00
msg()
{
2010-03-29 13:22:29 +00:00
echo "$*"
2010-03-29 13:21:24 +00:00
}
checksum()
{
if [ -x /usr/bin/md5sum ]; then
/usr/bin/md5sum "$@"
elif [ -x /bin/md5sum ]; then
/bin/md5sum "$@"
elif [ -x /usr/bin/cksum ]; then
/usr/bin/cksum "$@"
else
echo "NOCHECKSUM"
fi
}
self=`checksum "$SELF"`
2010-03-29 13:21:24 +00:00
checkself()
{
self_new=`checksum "$SELF"`
2010-03-29 13:21:24 +00:00
if [ x"$self" != x"$self_new" ]; then
msg "./all has changed."
if [ -z "$XONOTIC_FORBID_RERUN_ALL" ]; then
msg "Rerunning the requested operation to make sure."
export XONOTIC_FORBID_RERUN_ALL=1
exec "$SELF" "$@"
2010-03-29 13:21:24 +00:00
else
msg "Please try $SELF update, and then retry your requested operation."
2010-03-29 13:21:24 +00:00
exit 1
fi
fi
2010-03-29 13:24:49 +00:00
return 0
2010-03-29 13:21:24 +00:00
}
verbose()
{
2010-03-29 13:21:24 +00:00
msg "+ $*"
"$@"
}
2010-04-02 19:25:08 +00:00
visible_repo_name()
{
case "$1" in
.)
echo "the root directory"
;;
*)
echo "\"$1\""
;;
esac
}
2010-04-02 19:11:17 +00:00
check_mergeconflict()
{
if git ls-files -u | grep ' 1 '; then
echo
echo "MERGE CONFLICT."
echo "change into the \"$1\" project directory, and then:"
echo "- edit the files mentioned above with your favorite editor,"
echo " and fix the conflicts (marked with <<<<<<< blocks)"
echo "- for binary files, you can select the files using"
echo " git checkout --ours or git checkout --theirs"
echo "- when done with a file, 'git add' the file"
echo "- when done, 'git commit'"
echo
exit 1
fi
}
enter()
{
2010-04-15 09:38:55 +00:00
$2 cd "$1"
2010-04-02 19:11:17 +00:00
check_mergeconflict "$1"
}
2010-03-26 07:59:06 +00:00
repos_urls="
2010-03-20 13:23:39 +00:00
.
2010-03-18 15:46:07 +00:00
data/xonotic-data.pk3dir
data/xonotic-maps.pk3dir
data/xonotic-music.pk3dir
2010-03-23 12:17:13 +00:00
data/xonotic-nexcompat.pk3dir
2010-03-18 15:46:07 +00:00
darkplaces
2010-03-26 07:59:06 +00:00
fteqcc@git://github.com/Blub/qclib.git
2010-03-31 07:18:59 +00:00
div0-gittools@git://git.icculus.org/divverent/div0-gittools.git
2010-04-02 13:18:46 +00:00
netradiant
2010-03-18 15:46:07 +00:00
"
2010-03-26 07:59:06 +00:00
repos=`for X in $repos_urls; do echo "${X%%@*}"; done`
2010-03-18 15:57:21 +00:00
if [ "$#" = 0 ]; then
set -- help
fi
2010-03-18 15:46:07 +00:00
cmd=$1
shift
case "$cmd" in
2010-03-20 13:20:07 +00:00
update|pull)
2010-03-18 15:46:07 +00:00
base=`git config remote.origin.url`
base=${base%xonotic.git}
2010-03-26 07:59:06 +00:00
for dcomplete in $repos_urls; do
case "$dcomplete" in
*@*)
d=${dcomplete%%@*}
url=${dcomplete#*@}
switch=false
;;
*)
d=${dcomplete%%@*}
url=$base${d##*/}.git
switch=true
;;
esac
2010-03-18 15:46:07 +00:00
if [ -d "$d0/$d" ]; then
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
2010-03-20 13:29:27 +00:00
case "$d" in
.)
;;
*)
2010-03-26 07:59:06 +00:00
if $switch; then
verbose git config remote.origin.url "$url"
2010-03-26 07:59:06 +00:00
fi
2010-03-20 13:29:27 +00:00
;;
esac
verbose git config remote.origin.fetch "+refs/heads/*:refs/remotes/origin/*"
# TODO remove this line later
2010-04-17 18:47:12 +00:00
verbose git config core.autocrlf input
verbose git config core.safecrlf true
r=`git symbolic-ref HEAD`
r=${r#refs/heads/}
if git config branch.$r.remote >/dev/null 2>&1; then
if ! verbose git pull; then
check_mergeconflict "$d"
exit 1 # FATAL
fi
2010-04-02 19:11:17 +00:00
fi
2010-04-02 18:14:19 +00:00
cd "$d00"
2010-04-02 21:14:58 +00:00
checkself "$cmd" "$@"
2010-03-29 13:21:24 +00:00
cd "$d0/$d"
verbose git remote prune origin
2010-03-18 15:46:07 +00:00
cd "$d0"
else
verbose git clone "$url" "$d0/$d"
2010-03-18 15:46:07 +00:00
fi
done
;;
checkout|switch)
2010-03-18 15:46:07 +00:00
remote=$1
branch=$2
if [ -z "$branch" ]; then
branch=$remote
remote=origin
fi
exists=false
for d in $repos; do
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
2010-03-18 15:46:07 +00:00
if git rev-parse "refs/heads/$branch" >/dev/null 2>&1; then
exists=true
verbose git checkout "$branch"
2010-03-18 15:46:07 +00:00
elif git rev-parse "refs/remotes/$remote/$branch" >/dev/null 2>&1; then
exists=true
verbose git checkout --track -b "$branch" "$remote/$branch"
2010-03-18 15:46:07 +00:00
else
verbose git checkout master
2010-03-18 15:46:07 +00:00
fi
2010-04-02 18:14:19 +00:00
cd "$d00"
2010-04-02 21:14:58 +00:00
checkself "$cmd" "$@"
2010-04-02 18:14:19 +00:00
cd "$d0"
2010-03-18 15:46:07 +00:00
done
if ! $exists; then
echo "The requested branch was not found in any repository."
fi
exec "$SELF" branch
2010-03-18 15:46:07 +00:00
;;
branch)
2010-03-20 13:23:39 +00:00
remote=$1
branch=$2
srcbranch=$3
2010-03-20 13:23:39 +00:00
if [ -z "$branch" ]; then
branch=$remote
remote=origin
fi
if [ -z "$srcbranch" ]; then
srcbranch=master
fi
2010-03-20 13:23:39 +00:00
if [ -z "$branch" ]; then
for d in $repos; do
2010-04-02 19:11:17 +00:00
enter "$d0/$d"
r=`git symbolic-ref HEAD`
r=${r#refs/heads/}
echo "$d is at $r"
cd "$d0"
done
else
for d in $repos; do
2010-04-02 19:25:08 +00:00
dv=`visible_repo_name "$d"`
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
a=
while [ x"$a" != x"y" -a x"$a" != x"n" ]; do
2010-04-02 19:25:08 +00:00
echo "Branch in $dv?"
read -r a
done
2010-03-20 13:23:39 +00:00
if [ x"$a" = x"y" ]; then
verbose git push "$remote" "$srcbranch":"$branch"
verbose git checkout --track -b "$branch" "$remote/$branch"
fi
cd "$d0"
done
"$SELF" branch
fi
2010-03-18 15:46:07 +00:00
;;
branches)
for d in $repos; do
2010-04-02 19:11:17 +00:00
enter "$d0/$d"
2010-03-18 15:46:07 +00:00
echo "In $d:"
2010-04-15 09:38:55 +00:00
git branch -a -v -v | cut -c 3- | while read -r BRANCH REV UPSTREAM TEXT; do
case "$UPSTREAM" in
\[*)
UPSTREAM=${UPSTREAM#\[}
UPSTREAM=${UPSTREAM%\]}
UPSTREAM=${UPSTREAM%:*}
;;
*)
TEXT="$UPSTREAM $TEXT"
UPSTREAM=
;;
esac
if [ x"$REV" = x"->" ]; then
continue
fi
BRANCH=${BRANCH#remotes/}
echo -n " $BRANCH"
if [ -n "$UPSTREAM" ]; then
echo -n " (tracking $UPSTREAM)"
fi
#echo " $TEXT"
echo
done
2010-03-18 15:46:07 +00:00
done
;;
merge)
for d in $repos; do
2010-04-02 19:25:08 +00:00
dv=`visible_repo_name "$d"`
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
r=`git symbolic-ref HEAD`
r=${r#refs/heads/}
if git log HEAD..origin/master | grep .; then
# we have uncommitted changes
a=
while [ x"$a" != x"y" -a x"$a" != x"n" ]; do
2010-04-02 19:25:08 +00:00
echo "Could merge from \"master\" into \"$r\" in $dv. Do it?"
read -r a
done
if [ x"$a" = x"y" ]; then
if ! verbose git merge origin/master; then
2010-04-02 19:11:17 +00:00
check_mergeconflict "$d"
exit 1 # this should ALWAYS be fatal
fi
fi
fi
cd "$d0"
done
;;
push|commit)
submit=$1
2010-03-20 13:20:07 +00:00
for d in $repos; do
2010-04-02 19:25:08 +00:00
dv=`visible_repo_name "$d"`
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
2010-03-20 13:20:07 +00:00
r=`git symbolic-ref HEAD`
r=${r#refs/heads/}
if git diff HEAD | grep .; then
# we have uncommitted changes
a=
while [ x"$a" != x"y" -a x"$a" != x"n" ]; do
2010-04-02 19:25:08 +00:00
echo "Uncommitted changes in \"$r\" in $dv. Commit?"
read -r a
done
if [ x"$a" = x"y" ]; then
verbose git commit -a
fi
fi
2010-04-16 17:36:41 +00:00
rem=`git config "branch.$r.remote" || echo origin`
if git log "$rem/$r".."$r" | grep .; then
a=
2010-03-20 13:23:39 +00:00
while [ x"$a" != x"y" -a x"$a" != x"n" ]; do
2010-04-02 19:25:08 +00:00
echo "Push \"$r\" in $dv?"
2010-03-20 13:23:39 +00:00
read -r a
done
if [ x"$a" = x"y" ]; then
2010-04-16 17:36:41 +00:00
verbose git push "$rem" HEAD
2010-03-20 13:23:39 +00:00
fi
2010-03-20 13:20:07 +00:00
fi
if [ x"$submit" = x"-s" ]; then
case "$r" in
*/*)
verbose git push "$rem" HEAD:"${r%%/*}/finished/${r#*/}"
;;
esac
fi
2010-03-20 13:20:07 +00:00
cd "$d0"
done
;;
2010-03-24 12:11:30 +00:00
compile)
if [ -z "$MAKEFLAGS" ]; then
if [ -f /proc/cpuinfo ]; then
ncpus=$((`grep -c '^processor :' /proc/cpuinfo`+0))
if [ $ncpus -gt 1 ]; then
MAKEFLAGS=-j$ncpus
fi
fi
fi
2010-04-15 09:38:55 +00:00
enter "$d0/fteqcc" verbose
verbose make $MAKEFLAGS
2010-04-15 09:38:55 +00:00
enter "$d0/data/xonotic-data.pk3dir" verbose
verbose make FTEQCC="$d0/fteqcc/fteqcc.bin" $MAKEFLAGS
2010-04-15 09:38:55 +00:00
enter "$d0/darkplaces" verbose
verbose make $MAKEFLAGS sv-debug
verbose make $MAKEFLAGS cl-debug
verbose make $MAKEFLAGS sdl-debug
;;
run)
client=-sdl
case "$1" in
sdl|glx|agl|dedicated)
client=-$1
shift
;;
wgl)
client=
shift
;;
esac
if ! [ -x "darkplaces/darkplaces$client" ]; then
if [ -x "darkplaces/darkplaces$client.exe" ]; then
client=$client.exe
else
echo "Client darkplaces/darkplaces$client not found, aborting"
exit 1
fi
fi
#verbose "darkplaces/darkplaces$client" -xonotic "$@"
verbose "darkplaces/darkplaces$client" -nexuiz -customgamename Xonotic -customgamedirname1 data -customgamedirname2 "" -customgamescreenshotname xonotic -customgameuserdirname xonotic "$@"
2010-03-24 12:11:30 +00:00
;;
each|foreach)
2010-03-25 14:37:47 +00:00
for d in $repos; do
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
verbose "$@"
2010-03-25 14:37:47 +00:00
cd "$d0"
done
;;
2010-04-15 09:38:55 +00:00
save-patches)
outfile=$1
patchdir=`mktemp -d -t save-patches.XXXXXX`
for d in $repos; do
enter "$d0/$d" verbose
git branch -v -v | cut -c 3- | {
i=0
while read -r BRANCH REV UPSTREAM TEXT; do
case "$UPSTREAM" in
\[*)
UPSTREAM=${UPSTREAM#\[}
UPSTREAM=${UPSTREAM%\]}
UPSTREAM=${UPSTREAM%:*}
TRACK=true
;;
*)
UPSTREAM=origin/master
TRACK=false
;;
esac
if [ x"$REV" = x"->" ]; then
continue
fi
2010-04-15 09:43:03 +00:00
if git format-patch -o "$patchdir/$i" "$UPSTREAM".."$BRANCH"; then
2010-04-15 09:38:55 +00:00
echo "$d" > "$patchdir/$i/info.txt"
2010-04-15 09:43:03 +00:00
echo "$BRANCH" >> "$patchdir/$i/info.txt"
2010-04-15 09:38:55 +00:00
echo "$UPSTREAM" >> "$patchdir/$i/info.txt"
echo "$TRACK" >> "$patchdir/$i/info.txt"
i=$(($i+1))
else
rm -rf "$patchdir/$i"
fi
done
}
done
( cd "$patchdir" && tar cvzf - . ) > "$outfile"
rm -rf "$patchdir"
;;
restore-patches)
infile=$1
patchdir=`mktemp -d -t restore-patches.XXXXXX`
( cd "$patchdir" && tar xvzf - ) < "$infile"
# detach the head
for P in "$patchdir"/*/info.txt; do
D=${P%/info.txt}
exec 3<"$P"
read -r d <&3
read -r BRANCH <&3
read -r UPSTREAM <&3
read -r TRACK <&3
verbose git checkout HEAD^0
verbose git branch -D "$BRANCH"
if [ x"$TRACK" = x"true" ]; then
verbose git checkout --track -b "$BRANCH" "$UPSTREAM"
else
verbose git branch -b "$BRANCH" "$UPSTREAM"
fi
verbose git am "$D"
done
rm -rf "$patchdir"
;;
2010-03-18 15:46:07 +00:00
*)
echo "Usage:"
echo " $SELF pull"
echo " $SELF merge"
echo " $SELF push [-s]"
echo " $SELF branches"
echo " $SELF branch [<remote>] <branchname>"
echo " $SELF branch <remote> <branchname> <srcbranchname>"
echo " $SELF checkout [<remote>] <branchname>"
echo " $SELF compile"
echo " $SELF run <client> <options>"
echo " $SELF each <command>"
2010-03-18 15:46:07 +00:00
;;
esac